import 'dart:io';

import 'package:dio/adapter.dart';
import 'package:dio/dio.dart';
import 'package:m2p_flutter_base/http/logging.dart';
import 'package:m2p_flutter_base/m2p_encrypt_decrypt_config.dart';
/*/Users/chinnadurai/Documents/flutter/.pub-cache/git/m2p_flutter_base-46ddf34e90c498da9013d623447c63c9ec8dc9f0/
android/src/main/kotlin/com/example/encrypt_decrypt/EncryptDecryptPlugin.kt.*/
class DioClient {
  static dynamic dioConfig({required String? url}) {
    final Dio dio = Dio(
      BaseOptions(
        baseUrl: M2PKeyesConfiguration.baseUrl!,
        connectTimeout: M2PKeyesConfiguration.connectTimeout,
        receiveTimeout: M2PKeyesConfiguration.receiveTimeout,
        followRedirects: true,
        headers: (M2PKeyesConfiguration.accessToken != null ||
                '' != M2PKeyesConfiguration.accessToken)
            ? {
                'authorization': 'Bearer ${M2PKeyesConfiguration.accessToken}',
                'access-token': '${M2PKeyesConfiguration.accessToken}'
              }
            : null,
        contentType: 'application/json',
      ),
    )..interceptors.add(Logging());

    (dio.httpClientAdapter as DefaultHttpClientAdapter).onHttpClientCreate =
        (HttpClient client) {
      client.badCertificateCallback =
          (X509Certificate cert, String host, int port) => true;
      return client;
    };
    return dio;
  }

  static dynamic errorHandling(DioError e) {
    /// When the server response, but with a incorrect status, such as 404, 503
    if (e.type == DioErrorType.response) {
      return DioErrorType.response;
    }
    if (e.type == DioErrorType.connectTimeout) {
      return 'Please check your internet connection';
    }
    if (e.type == DioErrorType.receiveTimeout) {
      return 'Unable to connect to the server';
    }
    if (e.type == DioErrorType.other) {
      return 'Something went wrong';
    }

    /// When the request is cancelled, dio will throw a error with this type.
    if (e.type == DioErrorType.cancel) {
      return 'Something went wrong';
    }
  }

  static List<dynamic>? listOfMultiPart(List<File> file) {
    final List<dynamic> multiPartValues = [];
    for (File element in file) {
      multiPartValues.add(MultipartFile.fromFile(
        element.path,
        // filename: element.path.split('/').last,
      ));
    }
    return multiPartValues;
  }
}
