import 'dart:ui';

import 'package:fluttertoast/fluttertoast.dart';

class M2PKeyesConfiguration {
  static late String? rsaPrivate;
  static late String? rsaPublic;
  static late String? baseUrl;
  static late String? deviceId;
  static bool isAPIRunning = false;

  //Dio Error message
  static const String connectionTimeout =
      'Connection Timeout... Please try again after some time';
  static const String internalServerError =
      'Internal Server Error... Please try again after some time';

  //Dio configuration
  static late String? accessToken;
  static int connectTimeout = 60000;
  static int receiveTimeout = 60000;

  static void apiErrorStatus(
      {String? errorString,
      ToastGravity? position,
      Toast? toastLength = Toast.LENGTH_LONG,
      Color backgroundColor = const Color(0xFF101010),
      Color textColor = const Color(0xffffffff)}) {
    Fluttertoast.showToast(
        msg: errorString!,
        toastLength: toastLength,
        gravity: position ?? ToastGravity.CENTER,
        timeInSecForIosWeb: 3,
        backgroundColor: backgroundColor,
        textColor: textColor,
        fontSize: 14.0);
  }
}

class M2PDioAtttributeConfiguration {
  //Dio Atttribute configuration;
  //Ex: responseMessageAttribute = message;
  //Ex: accessToken = access-token;
  //Ex: status = status;
  static late String? responseMessageAttribute;
  static late String? accessToken;
  static late String? status;
}
