import 'package:flutter/material.dart';

class CustomText extends StatefulWidget {
  const CustomText(
    this.text, {
    Key? key,
    this.fontWeight = FontWeight.w400,
    this.fontStyle = FontStyle.normal,
    this.fontSize = 12,
    this.color = const Color(0xff1c1d22),
    this.lineHeight = 1.5,
    this.textAlign = TextAlign.left,
    this.onTap,
    this.isUnderLine = false,
    this.isSingleLine = false,
    this.letterSpacing,
    this.style = const TextStyle(
      decoration: TextDecoration.none,
      color: Color(0xff1c1d22),
      fontSize: 12,
      height: 1.5,
    ),
    this.maxLines,
  }) : super(key: key);
  final String text;
  final double fontSize;
  final Color color;
  final double lineHeight;
  final TextAlign textAlign;
  final GestureTapCallback? onTap;
  final bool isUnderLine;
  final bool isSingleLine;
  final int? maxLines;
  final FontWeight? fontWeight;
  final FontStyle fontStyle;
  final double? letterSpacing;
  final TextStyle? style;

  @override
  // ignore: library_private_types_in_public_api
  _CustomTextState createState() => _CustomTextState();
}

class _CustomTextState extends State<CustomText> {
  @override
  Widget build(BuildContext context) {
    final Text textWidget = Text(widget.text,
        textAlign: widget.textAlign,
        overflow: widget.isSingleLine ? TextOverflow.ellipsis : null,
        maxLines: widget.maxLines,
        style: widget.style);

    if (widget.onTap != null) {
      return InkWell(
        onTap: widget.onTap,
        child: textWidget,
      );
    } else {
      return textWidget;
    }
  }
}
